use hence;

use crate::parser;

#[derive(Debug)]

pub struct Data {
    pub body: Vec<hence::parser::ast::Node>,
}

impl Data {
    pub fn new() -> Self {
        Self {
            body: Vec::new(),
        }
    }
}

// pub fn create_call(list: Vec<parser::ast::Node>) -> Result<Call, &'static str> {
//     let mut raw_content = list.iter();
//     let content = raw_content.by_ref();

//     let name = match content
//         .skip_while(|n| matches!(n, parser::ast::Node::Comment(_)))
//         .next()
//     {
//         Some(node) => match node {
//             parser::ast::Node::String(x)
//             | parser::ast::Node::Symbol(x)
//             | parser::ast::Node::Literal(x) => x.clone(),
//             _ => return Err("Invalid call name node literal"),
//         },
//         _ => return Err("Cannot create call from empty list"),
//     };
//     let args: Vec<_> = content.collect();
//     dbg!(args);

//     Ok(Call {
//         name,
//         args: Vec::new(),
//     })
// }

pub fn compile(ast: parser::ast::AST, data: &mut Data) -> Result<(), &str> {
    let mut iter = ast.body.into_iter().peekable();
    while let Some(node) = iter.next() {
        match node {
            parser::ast::Node::Comment(_) => {}
            parser::ast::Node::String(_) => return Err("Unexpected string on top level"),
            parser::ast::Node::Number(_) => return Err("Unexpected number on top level"),
            parser::ast::Node::Symbol(_) => return Err("Unexpected symbol on top level"),
            parser::ast::Node::Literal(_) => return Err("Unexpected literal on top level"),

            parser::ast::Node::List(x) => {
                dbg!(&x);
            }
        }
    }

    Ok(())
}
